diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/ipv4-static-routing.cc ns-3.40/src/internet/model/ipv4-static-routing.cc
--- ns-3.39/src/internet/model/ipv4-static-routing.cc	2023-07-05 14:23:47.853427400 -0700
+++ ns-3.40/src/internet/model/ipv4-static-routing.cc	2023-09-27 13:30:37.658839200 -0700
@@ -78,7 +78,7 @@
 
     if (!LookupRoute(route, metric))
     {
-        Ipv4RoutingTableEntry* routePtr = new Ipv4RoutingTableEntry(route);
+        auto routePtr = new Ipv4RoutingTableEntry(route);
         m_networkRoutes.emplace_back(routePtr, metric);
     }
 }
@@ -95,7 +95,7 @@
         Ipv4RoutingTableEntry::CreateNetworkRouteTo(network, networkMask, interface);
     if (!LookupRoute(route, metric))
     {
-        Ipv4RoutingTableEntry* routePtr = new Ipv4RoutingTableEntry(route);
+        auto routePtr = new Ipv4RoutingTableEntry(route);
 
         m_networkRoutes.emplace_back(routePtr, metric);
     }
@@ -133,7 +133,7 @@
 {
     NS_LOG_FUNCTION(this << origin << " " << group << " " << inputInterface << " "
                          << &outputInterfaces);
-    Ipv4MulticastRoutingTableEntry* route = new Ipv4MulticastRoutingTableEntry();
+    auto route = new Ipv4MulticastRoutingTableEntry();
     *route = Ipv4MulticastRoutingTableEntry::CreateMulticastRoute(origin,
                                                                   group,
                                                                   inputInterface,
@@ -148,9 +148,9 @@
 Ipv4StaticRouting::SetDefaultMulticastRoute(uint32_t outputInterface)
 {
     NS_LOG_FUNCTION(this << outputInterface);
-    Ipv4RoutingTableEntry* route = new Ipv4RoutingTableEntry();
-    Ipv4Address network = Ipv4Address("224.0.0.0");
-    Ipv4Mask networkMask = Ipv4Mask("240.0.0.0");
+    auto route = new Ipv4RoutingTableEntry();
+    Ipv4Address network("224.0.0.0");
+    Ipv4Mask networkMask("240.0.0.0");
     *route = Ipv4RoutingTableEntry::CreateNetworkRouteTo(network, networkMask, outputInterface);
     m_networkRoutes.emplace_back(route, 0);
 }
@@ -172,7 +172,7 @@
     if (index < m_multicastRoutes.size())
     {
         uint32_t tmp = 0;
-        for (MulticastRoutesCI i = m_multicastRoutes.begin(); i != m_multicastRoutes.end(); i++)
+        for (auto i = m_multicastRoutes.begin(); i != m_multicastRoutes.end(); i++)
         {
             if (tmp == index)
             {
@@ -190,7 +190,7 @@
                                         uint32_t inputInterface)
 {
     NS_LOG_FUNCTION(this << origin << " " << group << " " << inputInterface);
-    for (MulticastRoutesI i = m_multicastRoutes.begin(); i != m_multicastRoutes.end(); i++)
+    for (auto i = m_multicastRoutes.begin(); i != m_multicastRoutes.end(); i++)
     {
         Ipv4MulticastRoutingTableEntry* route = *i;
         if (origin == route->GetOrigin() && group == route->GetGroup() &&
@@ -209,7 +209,7 @@
 {
     NS_LOG_FUNCTION(this << index);
     uint32_t tmp = 0;
-    for (MulticastRoutesI i = m_multicastRoutes.begin(); i != m_multicastRoutes.end(); i++)
+    for (auto i = m_multicastRoutes.begin(); i != m_multicastRoutes.end(); i++)
     {
         if (tmp == index)
         {
@@ -224,7 +224,7 @@
 bool
 Ipv4StaticRouting::LookupRoute(const Ipv4RoutingTableEntry& route, uint32_t metric)
 {
-    for (NetworkRoutesI j = m_networkRoutes.begin(); j != m_networkRoutes.end(); j++)
+    for (auto j = m_networkRoutes.begin(); j != m_networkRoutes.end(); j++)
     {
         Ipv4RoutingTableEntry* rtentry = j->first;
 
@@ -261,7 +261,7 @@
         return rtentry;
     }
 
-    for (NetworkRoutesI i = m_networkRoutes.begin(); i != m_networkRoutes.end(); i++)
+    for (auto i = m_networkRoutes.begin(); i != m_networkRoutes.end(); i++)
     {
         Ipv4RoutingTableEntry* j = i->first;
         uint32_t metric = i->second;
@@ -328,7 +328,7 @@
     NS_LOG_FUNCTION(this << origin << " " << group << " " << interface);
     Ptr<Ipv4MulticastRoute> mrtentry = nullptr;
 
-    for (MulticastRoutesI i = m_multicastRoutes.begin(); i != m_multicastRoutes.end(); i++)
+    for (auto i = m_multicastRoutes.begin(); i != m_multicastRoutes.end(); i++)
     {
         Ipv4MulticastRoutingTableEntry* route = *i;
         //
@@ -385,7 +385,7 @@
     Ipv4Address dest("0.0.0.0");
     uint32_t shortest_metric = 0xffffffff;
     Ipv4RoutingTableEntry* result = nullptr;
-    for (NetworkRoutesI i = m_networkRoutes.begin(); i != m_networkRoutes.end(); i++)
+    for (auto i = m_networkRoutes.begin(); i != m_networkRoutes.end(); i++)
     {
         Ipv4RoutingTableEntry* j = i->first;
         uint32_t metric = i->second;
@@ -417,7 +417,7 @@
 {
     NS_LOG_FUNCTION(this << index);
     uint32_t tmp = 0;
-    for (NetworkRoutesCI j = m_networkRoutes.begin(); j != m_networkRoutes.end(); j++)
+    for (auto j = m_networkRoutes.begin(); j != m_networkRoutes.end(); j++)
     {
         if (tmp == index)
         {
@@ -435,7 +435,7 @@
 {
     NS_LOG_FUNCTION(this << index);
     uint32_t tmp = 0;
-    for (NetworkRoutesCI j = m_networkRoutes.begin(); j != m_networkRoutes.end(); j++)
+    for (auto j = m_networkRoutes.begin(); j != m_networkRoutes.end(); j++)
     {
         if (tmp == index)
         {
@@ -453,7 +453,7 @@
 {
     NS_LOG_FUNCTION(this << index);
     uint32_t tmp = 0;
-    for (NetworkRoutesI j = m_networkRoutes.begin(); j != m_networkRoutes.end(); j++)
+    for (auto j = m_networkRoutes.begin(); j != m_networkRoutes.end(); j++)
     {
         if (tmp == index)
         {
@@ -588,12 +588,11 @@
 Ipv4StaticRouting::DoDispose()
 {
     NS_LOG_FUNCTION(this);
-    for (NetworkRoutesI j = m_networkRoutes.begin(); j != m_networkRoutes.end();
-         j = m_networkRoutes.erase(j))
+    for (auto j = m_networkRoutes.begin(); j != m_networkRoutes.end(); j = m_networkRoutes.erase(j))
     {
         delete (j->first);
     }
-    for (MulticastRoutesI i = m_multicastRoutes.begin(); i != m_multicastRoutes.end();
+    for (auto i = m_multicastRoutes.begin(); i != m_multicastRoutes.end();
          i = m_multicastRoutes.erase(i))
     {
         delete (*i);
@@ -628,7 +627,7 @@
 {
     NS_LOG_FUNCTION(this << i);
     // Remove all static routes that are going through this interface
-    for (NetworkRoutesI it = m_networkRoutes.begin(); it != m_networkRoutes.end();)
+    for (auto it = m_networkRoutes.begin(); it != m_networkRoutes.end();)
     {
         if (it->first->GetInterface() == i)
         {
@@ -671,7 +670,7 @@
     Ipv4Mask networkMask = address.GetMask();
     // Remove all static routes that are going through this interface
     // which reference this network
-    for (NetworkRoutesI it = m_networkRoutes.begin(); it != m_networkRoutes.end();)
+    for (auto it = m_networkRoutes.begin(); it != m_networkRoutes.end();)
     {
         if (it->first->GetInterface() == interface && it->first->IsNetwork() &&
             it->first->GetDestNetwork() == networkAddress &&
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/ipv4-static-routing.h ns-3.40/src/internet/model/ipv4-static-routing.h
--- ns-3.39/src/internet/model/ipv4-static-routing.h	2023-07-05 14:23:47.853427400 -0700
+++ ns-3.40/src/internet/model/ipv4-static-routing.h	2023-09-27 13:30:37.658839200 -0700
@@ -21,10 +21,11 @@
 #ifndef IPV4_STATIC_ROUTING_H
 #define IPV4_STATIC_ROUTING_H
 
+#include "ipv4-header.h"
+#include "ipv4-routing-protocol.h"
+#include "ipv4.h"
+
 #include "ns3/ipv4-address.h"
-#include "ns3/ipv4-header.h"
-#include "ns3/ipv4-routing-protocol.h"
-#include "ns3/ipv4.h"
 #include "ns3/ptr.h"
 #include "ns3/socket.h"
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/ipv6-address-generator.cc ns-3.40/src/internet/model/ipv6-address-generator.cc
--- ns-3.39/src/internet/model/ipv6-address-generator.cc	2023-07-05 14:23:47.853427400 -0700
+++ ns-3.40/src/internet/model/ipv6-address-generator.cc	2023-09-27 13:30:37.658839200 -0700
@@ -515,7 +515,7 @@
         taddr[15] += 1;
         if (Ipv6Address(addr) == Ipv6Address(taddr))
         {
-            std::list<Entry>::iterator j = i;
+            auto j = i;
             ++j;
 
             if (j != m_entries.end())
@@ -581,9 +581,7 @@
     uint8_t addr[16];
     address.GetBytes(addr);
 
-    std::list<Entry>::iterator i;
-
-    for (i = m_entries.begin(); i != m_entries.end(); ++i)
+    for (auto i = m_entries.begin(); i != m_entries.end(); ++i)
     {
         NS_LOG_LOGIC("examine entry: " << Ipv6Address((*i).addrLow) << " to "
                                        << Ipv6Address((*i).addrHigh));
@@ -594,10 +592,10 @@
         {
             NS_LOG_LOGIC("Ipv6AddressGeneratorImpl::IsAddressAllocated(): Address Collision: "
                          << Ipv6Address(addr));
-            return false;
+            return true;
         }
     }
-    return true;
+    return false;
 }
 
 bool
@@ -610,9 +608,7 @@
         "Ipv6AddressGeneratorImpl::IsNetworkAllocated(): network address and mask don't match "
             << address << " " << prefix);
 
-    std::list<Entry>::iterator i;
-
-    for (i = m_entries.begin(); i != m_entries.end(); ++i)
+    for (auto i = m_entries.begin(); i != m_entries.end(); ++i)
     {
         NS_LOG_LOGIC("examine entry: " << Ipv6Address((*i).addrLow) << " to "
                                        << Ipv6Address((*i).addrHigh));
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/ipv6-end-point-demux.cc ns-3.40/src/internet/model/ipv6-end-point-demux.cc
--- ns-3.39/src/internet/model/ipv6-end-point-demux.cc	2023-07-05 14:23:47.853427400 -0700
+++ ns-3.40/src/internet/model/ipv6-end-point-demux.cc	2023-09-27 13:30:37.658839200 -0700
@@ -39,7 +39,7 @@
 Ipv6EndPointDemux::~Ipv6EndPointDemux()
 {
     NS_LOG_FUNCTION(this);
-    for (EndPointsI i = m_endPoints.begin(); i != m_endPoints.end(); i++)
+    for (auto i = m_endPoints.begin(); i != m_endPoints.end(); i++)
     {
         Ipv6EndPoint* endPoint = *i;
         delete endPoint;
@@ -51,7 +51,7 @@
 Ipv6EndPointDemux::LookupPortLocal(uint16_t port)
 {
     NS_LOG_FUNCTION(this << port);
-    for (EndPointsI i = m_endPoints.begin(); i != m_endPoints.end(); i++)
+    for (auto i = m_endPoints.begin(); i != m_endPoints.end(); i++)
     {
         if ((*i)->GetLocalPort() == port)
         {
@@ -65,7 +65,7 @@
 Ipv6EndPointDemux::LookupLocal(Ptr<NetDevice> boundNetDevice, Ipv6Address addr, uint16_t port)
 {
     NS_LOG_FUNCTION(this << addr << port);
-    for (EndPointsI i = m_endPoints.begin(); i != m_endPoints.end(); i++)
+    for (auto i = m_endPoints.begin(); i != m_endPoints.end(); i++)
     {
         if ((*i)->GetLocalPort() == port && (*i)->GetLocalAddress() == addr &&
             (*i)->GetBoundNetDevice() == boundNetDevice)
@@ -86,7 +86,7 @@
         NS_LOG_WARN("Ephemeral port allocation failed.");
         return nullptr;
     }
-    Ipv6EndPoint* endPoint = new Ipv6EndPoint(Ipv6Address::GetAny(), port);
+    auto endPoint = new Ipv6EndPoint(Ipv6Address::GetAny(), port);
     m_endPoints.push_back(endPoint);
     NS_LOG_DEBUG("Now have >>" << m_endPoints.size() << "<< endpoints.");
     return endPoint;
@@ -102,7 +102,7 @@
         NS_LOG_WARN("Ephemeral port allocation failed.");
         return nullptr;
     }
-    Ipv6EndPoint* endPoint = new Ipv6EndPoint(address, port);
+    auto endPoint = new Ipv6EndPoint(address, port);
     m_endPoints.push_back(endPoint);
     NS_LOG_DEBUG("Now have >>" << m_endPoints.size() << "<< endpoints.");
     return endPoint;
@@ -125,7 +125,7 @@
         NS_LOG_WARN("Duplicated endpoint.");
         return nullptr;
     }
-    Ipv6EndPoint* endPoint = new Ipv6EndPoint(address, port);
+    auto endPoint = new Ipv6EndPoint(address, port);
     m_endPoints.push_back(endPoint);
     NS_LOG_DEBUG("Now have >>" << m_endPoints.size() << "<< endpoints.");
     return endPoint;
@@ -139,7 +139,7 @@
                             uint16_t peerPort)
 {
     NS_LOG_FUNCTION(this << boundNetDevice << localAddress << localPort << peerAddress << peerPort);
-    for (EndPointsI i = m_endPoints.begin(); i != m_endPoints.end(); i++)
+    for (auto i = m_endPoints.begin(); i != m_endPoints.end(); i++)
     {
         if ((*i)->GetLocalPort() == localPort && (*i)->GetLocalAddress() == localAddress &&
             (*i)->GetPeerPort() == peerPort && (*i)->GetPeerAddress() == peerAddress &&
@@ -149,7 +149,7 @@
             return nullptr;
         }
     }
-    Ipv6EndPoint* endPoint = new Ipv6EndPoint(localAddress, localPort);
+    auto endPoint = new Ipv6EndPoint(localAddress, localPort);
     endPoint->SetPeer(peerAddress, peerPort);
     m_endPoints.push_back(endPoint);
 
@@ -162,7 +162,7 @@
 Ipv6EndPointDemux::DeAllocate(Ipv6EndPoint* endPoint)
 {
     NS_LOG_FUNCTION(this);
-    for (EndPointsI i = m_endPoints.begin(); i != m_endPoints.end(); i++)
+    for (auto i = m_endPoints.begin(); i != m_endPoints.end(); i++)
     {
         if (*i == endPoint)
         {
@@ -193,7 +193,7 @@
     EndPoints retval4; /* Exact match on all 4 */
 
     NS_LOG_DEBUG("Looking up endpoint for destination address " << daddr);
-    for (EndPointsI i = m_endPoints.begin(); i != m_endPoints.end(); i++)
+    for (auto i = m_endPoints.begin(); i != m_endPoints.end(); i++)
     {
         Ipv6EndPoint* endP = *i;
 
@@ -313,7 +313,7 @@
     uint32_t genericity = 3;
     Ipv6EndPoint* generic = nullptr;
 
-    for (EndPointsI i = m_endPoints.begin(); i != m_endPoints.end(); i++)
+    for (auto i = m_endPoints.begin(); i != m_endPoints.end(); i++)
     {
         uint32_t tmp = 0;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/ipv6-end-point.h ns-3.40/src/internet/model/ipv6-end-point.h
--- ns-3.39/src/internet/model/ipv6-end-point.h	2023-07-05 14:23:47.853427400 -0700
+++ ns-3.40/src/internet/model/ipv6-end-point.h	2023-09-27 13:30:37.658839200 -0700
@@ -20,10 +20,11 @@
 #ifndef IPV6_END_POINT_H
 #define IPV6_END_POINT_H
 
+#include "ipv6-header.h"
+#include "ipv6-interface.h"
+
 #include "ns3/callback.h"
 #include "ns3/ipv6-address.h"
-#include "ns3/ipv6-header.h"
-#include "ns3/ipv6-interface.h"
 #include "ns3/net-device.h"
 
 #include <stdint.h>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/ipv6-extension.cc ns-3.40/src/internet/model/ipv6-extension.cc
--- ns-3.39/src/internet/model/ipv6-extension.cc	2023-07-05 14:23:47.853427400 -0700
+++ ns-3.40/src/internet/model/ipv6-extension.cc	2023-09-27 13:30:37.658839200 -0700
@@ -109,7 +109,7 @@
 
     uint8_t processedSize = 0;
     uint32_t size = p->GetSize();
-    uint8_t* data = new uint8_t[size];
+    auto data = new uint8_t[size];
     p->CopyData(data, size);
 
     uint8_t optionType = 0;
@@ -354,7 +354,7 @@
 {
     NS_LOG_FUNCTION(this);
 
-    for (MapFragments_t::iterator it = m_fragments.begin(); it != m_fragments.end(); it++)
+    for (auto it = m_fragments.begin(); it != m_fragments.end(); it++)
     {
         it->second = nullptr;
     }
@@ -408,7 +408,7 @@
     Ipv6Header ipHeader = ipv6Header;
     ipHeader.SetNextHeader(fragmentHeader.GetNextHeader());
 
-    MapFragments_t::iterator it = m_fragments.find(fragmentKey);
+    auto it = m_fragments.find(fragmentKey);
     if (it == m_fragments.end())
     {
         fragments = Create<Fragments>();
@@ -416,7 +416,7 @@
         NS_LOG_DEBUG("Insert new fragment key: src: "
                      << src << " IP hdr id " << identification << " m_fragments.size() "
                      << m_fragments.size() << " offset " << fragmentOffset);
-        FragmentsTimeoutsListI_t iter = SetTimeout(fragmentKey, ipHeader);
+        auto iter = SetTimeout(fragmentKey, ipHeader);
         fragments->SetTimeoutIter(iter);
     }
     else
@@ -487,7 +487,7 @@
     {
         if (nextHeader == Ipv6Header::IPV6_EXT_HOP_BY_HOP)
         {
-            Ipv6ExtensionHopByHopHeader* hopbyhopHeader = new Ipv6ExtensionHopByHopHeader();
+            auto hopbyhopHeader = new Ipv6ExtensionHopByHopHeader();
             p->RemoveHeader(*hopbyhopHeader);
 
             nextHeader = hopbyhopHeader->GetNextHeader();
@@ -541,8 +541,7 @@
         }
         else if (nextHeader == Ipv6Header::IPV6_EXT_DESTINATION)
         {
-            Ipv6ExtensionDestinationHeader* destinationHeader =
-                new Ipv6ExtensionDestinationHeader();
+            auto destinationHeader = new Ipv6ExtensionDestinationHeader();
             p->RemoveHeader(*destinationHeader);
 
             nextHeader = destinationHeader->GetNextHeader();
@@ -572,7 +571,7 @@
     uint32_t currentFragmentablePartSize = 0;
 
     bool moreFragment = true;
-    uint32_t identification = (uint32_t)m_uvar->GetValue(0, (uint32_t)-1);
+    auto identification = (uint32_t)m_uvar->GetValue(0, (uint32_t)-1);
     uint16_t offset = 0;
 
     do
@@ -599,29 +598,23 @@
 
         fragment->AddHeader(fragmentHeader);
 
-        for (std::list<std::pair<Ipv6ExtensionHeader*, uint8_t>>::iterator it =
-                 unfragmentablePart.begin();
-             it != unfragmentablePart.end();
-             it++)
+        for (auto it = unfragmentablePart.begin(); it != unfragmentablePart.end(); it++)
         {
             if (it->second == Ipv6Header::IPV6_EXT_HOP_BY_HOP)
             {
-                Ipv6ExtensionHopByHopHeader* p =
-                    dynamic_cast<Ipv6ExtensionHopByHopHeader*>(it->first);
+                auto p = dynamic_cast<Ipv6ExtensionHopByHopHeader*>(it->first);
                 NS_ASSERT(p != nullptr);
                 fragment->AddHeader(*p);
             }
             else if (it->second == Ipv6Header::IPV6_EXT_ROUTING)
             {
-                Ipv6ExtensionLooseRoutingHeader* p =
-                    dynamic_cast<Ipv6ExtensionLooseRoutingHeader*>(it->first);
+                auto p = dynamic_cast<Ipv6ExtensionLooseRoutingHeader*>(it->first);
                 NS_ASSERT(p != nullptr);
                 fragment->AddHeader(*p);
             }
             else if (it->second == Ipv6Header::IPV6_EXT_DESTINATION)
             {
-                Ipv6ExtensionDestinationHeader* p =
-                    dynamic_cast<Ipv6ExtensionDestinationHeader*>(it->first);
+                auto p = dynamic_cast<Ipv6ExtensionDestinationHeader*>(it->first);
                 NS_ASSERT(p != nullptr);
                 fragment->AddHeader(*p);
             }
@@ -636,10 +629,7 @@
         listFragments.emplace_back(fragment, ipv6Header);
     } while (moreFragment);
 
-    for (std::list<std::pair<Ipv6ExtensionHeader*, uint8_t>>::iterator it =
-             unfragmentablePart.begin();
-         it != unfragmentablePart.end();
-         it++)
+    for (auto it = unfragmentablePart.begin(); it != unfragmentablePart.end(); it++)
     {
         delete it->first;
     }
@@ -653,7 +643,7 @@
     NS_LOG_FUNCTION(this << fragmentKey.first << fragmentKey.second << ipHeader);
     Ptr<Fragments> fragments;
 
-    MapFragments_t::iterator it = m_fragments.find(fragmentKey);
+    auto it = m_fragments.find(fragmentKey);
     NS_ASSERT_MSG(it != m_fragments.end(),
                   "IPv6 Fragment timeout reached for non-existent fragment");
     fragments = it->second;
@@ -694,7 +684,7 @@
                  << key.second);
     m_timeoutEventList.emplace_back(Simulator::Now() + m_fragmentExpirationTimeout, key, ipHeader);
 
-    Ipv6ExtensionFragment::FragmentsTimeoutsListI_t iter = --m_timeoutEventList.end();
+    auto iter = --m_timeoutEventList.end();
 
     return (iter);
 }
@@ -730,7 +720,7 @@
 }
 
 Ipv6ExtensionFragment::Fragments::Fragments()
-    : m_moreFragment(0)
+    : m_moreFragment(false)
 {
 }
 
@@ -778,10 +768,7 @@
     {
         uint16_t lastEndOffset = 0;
 
-        for (std::list<std::pair<Ptr<Packet>, uint16_t>>::const_iterator it =
-                 m_packetFragments.begin();
-             it != m_packetFragments.end();
-             it++)
+        for (auto it = m_packetFragments.begin(); it != m_packetFragments.end(); it++)
         {
             if (lastEndOffset != it->second)
             {
@@ -801,9 +788,7 @@
 {
     Ptr<Packet> p = m_unfragmentable->Copy();
 
-    for (std::list<std::pair<Ptr<Packet>, uint16_t>>::const_iterator it = m_packetFragments.begin();
-         it != m_packetFragments.end();
-         it++)
+    for (auto it = m_packetFragments.begin(); it != m_packetFragments.end(); it++)
     {
         p->AddAtEnd(it->first);
     }
@@ -827,9 +812,7 @@
 
     uint16_t lastEndOffset = 0;
 
-    for (std::list<std::pair<Ptr<Packet>, uint16_t>>::const_iterator it = m_packetFragments.begin();
-         it != m_packetFragments.end();
-         it++)
+    for (auto it = m_packetFragments.begin(); it != m_packetFragments.end(); it++)
     {
         if (lastEndOffset != it->second)
         {
@@ -993,9 +976,7 @@
 Ipv6ExtensionRoutingDemux::DoDispose()
 {
     NS_LOG_FUNCTION(this);
-    for (Ipv6ExtensionRoutingList_t::iterator it = m_extensionsRouting.begin();
-         it != m_extensionsRouting.end();
-         it++)
+    for (auto it = m_extensionsRouting.begin(); it != m_extensionsRouting.end(); it++)
     {
         (*it)->Dispose();
         *it = nullptr;
@@ -1310,7 +1291,7 @@
 
     /** \todo */
 
-    return true;
+    return 1;
 }
 
 } /* namespace ns3 */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/ipv6-extension-demux.cc ns-3.40/src/internet/model/ipv6-extension-demux.cc
--- ns-3.39/src/internet/model/ipv6-extension-demux.cc	2023-07-05 14:23:47.853427400 -0700
+++ ns-3.40/src/internet/model/ipv6-extension-demux.cc	2023-09-27 13:30:37.658839200 -0700
@@ -58,7 +58,7 @@
 void
 Ipv6ExtensionDemux::DoDispose()
 {
-    for (Ipv6ExtensionList_t::iterator it = m_extensions.begin(); it != m_extensions.end(); it++)
+    for (auto it = m_extensions.begin(); it != m_extensions.end(); it++)
     {
         (*it)->Dispose();
         *it = nullptr;
@@ -83,7 +83,7 @@
 Ptr<Ipv6Extension>
 Ipv6ExtensionDemux::GetExtension(uint8_t extensionNumber)
 {
-    for (Ipv6ExtensionList_t::iterator i = m_extensions.begin(); i != m_extensions.end(); ++i)
+    for (auto i = m_extensions.begin(); i != m_extensions.end(); ++i)
     {
         if ((*i)->GetExtensionNumber() == extensionNumber)
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/ipv6-extension.h ns-3.40/src/internet/model/ipv6-extension.h
--- ns-3.39/src/internet/model/ipv6-extension.h	2023-07-05 14:23:47.853427400 -0700
+++ ns-3.40/src/internet/model/ipv6-extension.h	2023-09-27 13:30:37.658839200 -0700
@@ -21,12 +21,12 @@
 #define IPV6_EXTENSION_H
 
 #include "ipv6-extension-header.h"
+#include "ipv6-header.h"
 #include "ipv6-interface.h"
+#include "ipv6-l3-protocol.h"
 
 #include "ns3/buffer.h"
 #include "ns3/ipv6-address.h"
-#include "ns3/ipv6-header.h"
-#include "ns3/ipv6-l3-protocol.h"
 #include "ns3/node.h"
 #include "ns3/object.h"
 #include "ns3/packet.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/ipv6-extension-header.cc ns-3.40/src/internet/model/ipv6-extension-header.cc
--- ns-3.39/src/internet/model/ipv6-extension-header.cc	2023-07-05 14:23:47.853427400 -0700
+++ ns-3.40/src/internet/model/ipv6-extension-header.cc	2023-09-27 13:30:37.658839200 -0700
@@ -118,7 +118,7 @@
     m_length = i.ReadU8();
 
     uint32_t dataLength = GetLength() - 2;
-    uint8_t* data = new uint8_t[dataLength];
+    auto data = new uint8_t[dataLength];
     i.Read(data, dataLength);
 
     if (dataLength > m_data.GetSize())
@@ -175,7 +175,7 @@
 uint32_t
 OptionField::Deserialize(Buffer::Iterator start, uint32_t length)
 {
-    uint8_t* buf = new uint8_t[length];
+    auto buf = new uint8_t[length];
     start.Read(buf, length);
     m_optionData = Buffer();
     m_optionData.AddAtEnd(length);
@@ -613,9 +613,7 @@
        << " typeRouting = " << (uint32_t)GetTypeRouting()
        << " segmentsLeft = " << (uint32_t)GetSegmentsLeft() << " ";
 
-    for (std::vector<Ipv6Address>::const_iterator it = m_routersAddress.begin();
-         it != m_routersAddress.end();
-         it++)
+    for (auto it = m_routersAddress.begin(); it != m_routersAddress.end(); it++)
     {
         os << *it << " ";
     }
@@ -643,9 +641,7 @@
     i.WriteU8(GetSegmentsLeft());
     i.WriteU32(0);
 
-    for (VectorIpv6Address_t::const_iterator it = m_routersAddress.begin();
-         it != m_routersAddress.end();
-         it++)
+    for (auto it = m_routersAddress.begin(); it != m_routersAddress.end(); it++)
     {
         it->Serialize(buff);
         i.Write(buff, 16);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/ipv6-interface.cc ns-3.40/src/internet/model/ipv6-interface.cc
--- ns-3.39/src/internet/model/ipv6-interface.cc	2023-07-05 14:23:47.853427400 -0700
+++ ns-3.40/src/internet/model/ipv6-interface.cc	2023-09-27 13:30:37.658839200 -0700
@@ -215,7 +215,7 @@
     /* DAD handling */
     if (!addr.IsAny())
     {
-        for (Ipv6InterfaceAddressListCI it = m_addresses.begin(); it != m_addresses.end(); ++it)
+        for (auto it = m_addresses.begin(); it != m_addresses.end(); ++it)
         {
             if (it->first.GetAddress() == addr)
             {
@@ -282,7 +282,7 @@
     /* IPv6 interface has always at least one IPv6 Solicited Multicast address */
     NS_LOG_FUNCTION(this << address);
 
-    for (Ipv6InterfaceAddressListCI it = m_addresses.begin(); it != m_addresses.end(); ++it)
+    for (auto it = m_addresses.begin(); it != m_addresses.end(); ++it)
     {
         if (it->second == address)
         {
@@ -301,7 +301,7 @@
 
     if (m_addresses.size() > index)
     {
-        for (Ipv6InterfaceAddressListCI it = m_addresses.begin(); it != m_addresses.end(); ++it)
+        for (auto it = m_addresses.begin(); it != m_addresses.end(); ++it)
         {
             if (i == index)
             {
@@ -336,7 +336,7 @@
         NS_FATAL_ERROR("Removing index that does not exist in Ipv6Interface::RemoveAddress");
     }
 
-    for (Ipv6InterfaceAddressListI it = m_addresses.begin(); it != m_addresses.end(); ++it)
+    for (auto it = m_addresses.begin(); it != m_addresses.end(); ++it)
     {
         if (i == index)
         {
@@ -367,7 +367,7 @@
         return Ipv6InterfaceAddress();
     }
 
-    for (Ipv6InterfaceAddressListI it = m_addresses.begin(); it != m_addresses.end(); ++it)
+    for (auto it = m_addresses.begin(); it != m_addresses.end(); ++it)
     {
         if (it->first.GetAddress() == address)
         {
@@ -388,8 +388,7 @@
 {
     NS_LOG_FUNCTION(this << dst);
 
-    for (Ipv6InterfaceAddressList::const_iterator it = m_addresses.begin(); it != m_addresses.end();
-         ++it)
+    for (auto it = m_addresses.begin(); it != m_addresses.end(); ++it)
     {
         Ipv6InterfaceAddress ifaddr = it->first;
 
@@ -431,7 +430,7 @@
     NS_ASSERT(m_tc);
 
     /* check if destination is for one of our interface */
-    for (Ipv6InterfaceAddressListCI it = m_addresses.begin(); it != m_addresses.end(); ++it)
+    for (auto it = m_addresses.begin(); it != m_addresses.end(); ++it)
     {
         if (dest == it->first.GetAddress())
         {
@@ -559,7 +558,7 @@
 {
     NS_LOG_FUNCTION(this << address << state);
 
-    for (Ipv6InterfaceAddressListI it = m_addresses.begin(); it != m_addresses.end(); ++it)
+    for (auto it = m_addresses.begin(); it != m_addresses.end(); ++it)
     {
         if (it->first.GetAddress() == address)
         {
@@ -575,7 +574,7 @@
 {
     NS_LOG_FUNCTION(this << address << uid);
 
-    for (Ipv6InterfaceAddressListI it = m_addresses.begin(); it != m_addresses.end(); ++it)
+    for (auto it = m_addresses.begin(); it != m_addresses.end(); ++it)
     {
         if (it->first.GetAddress() == address)
         {
